#
# uspk05.rb
#
# $Id: uspk05.rb,v 1.1 2000/11/22 14:36:02 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


N = 200
M = 5
x = NArray.sfloat(N)
y0 = NArray.sfloat(N)
y1 = NArray.sfloat(N)
y2 = NArray.sfloat(N)
a = NArray.sfloat(M)

#-----------------------------------------------------------------------
dt = 1.0/(N-1)
for j in 0..M-1
  jj = j*2+1
  a[j] = (-1.0)**(j+1) *2.0/(jj*PI)
end

x = x.indgen * dt
for i in 0..N-1
  t = dt*i*2*PI
  y2[i] = 0.0
  for j in 0..M-1
    jj = j*2+1
    yy = a[j]*cos(jj*t)
    y2[i] = y2[i] + yy
  end
  y1[i] = a[0]*cos(t)

  if (t < PI/2.0 || t >= PI*3.0/2.0)
    y0[i] = -0.5
  else
    y0[i] = 0.5
  end
end

#-----------------------------------------------------------------------
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i

gropn iws

grfrm

usspnt(N, x, y0)
usspnt(N, x, y1)
usspnt(N, x, y2)

uspfit
grstrf

usdaxs

uulinz(N, x, y0, 1, 5)
uulinz(N, x, y1, 3, 1)
uulinz(N, x, y2, 2, 2)

grcls

